// from django/contrib/admin/static/admin/js/urlify.js
var LATIN_MAP = {
    'À': 'A', 'Á': 'A', 'Â': 'A', 'Ã': 'A', 'Ä': 'A', 'Å': 'A', 'Æ': 'AE',
    'Ç': 'C', 'È': 'E', 'É': 'E', 'Ê': 'E', 'Ë': 'E', 'Ì': 'I', 'Í': 'I',
    'Î': 'I', 'Ï': 'I', 'Ð': 'D', 'Ñ': 'N', 'Ò': 'O', 'Ó': 'O', 'Ô': 'O',
    'Õ': 'O', 'Ö': 'O', 'Ő': 'O', 'Ø': 'O', 'Ù': 'U', 'Ú': 'U', 'Û': 'U',
    'Ü': 'U', 'Ű': 'U', 'Ý': 'Y', 'Þ': 'TH', 'Ÿ': 'Y', 'ß': 'ss', 'à': 'a',
    'á': 'a', 'â': 'a', 'ã': 'a', 'ä': 'a', 'å': 'a', 'æ': 'ae', 'ç': 'c',
    'è': 'e', 'é': 'e', 'ê': 'e', 'ë': 'e', 'ì': 'i', 'í': 'i', 'î': 'i',
    'ï': 'i', 'ð': 'd', 'ñ': 'n', 'ò': 'o', 'ó': 'o', 'ô': 'o', 'õ': 'o',
    'ö': 'o', 'ő': 'o', 'ø': 'o', 'ù': 'u', 'ú': 'u', 'û': 'u', 'ü': 'u',
    'ű': 'u', 'ý': 'y', 'þ': 'th', 'ÿ': 'y'
};

function downcode(string) {
  return string.toLowerCase().replace(/[^A-Za-z0-9\[\] ]/g,function(a){ return LATIN_MAP[a]||a })
};

$(function() {
  var $sidebar = $('#sidebar');

  /* add & remove tile */
  $('div.cell, div#sidebar').delegate('a.remove-from-dashboard', 'click', function(e) {
    var dashboard = $(this).parents('.dashboardcell');
    var cell = $(this).parents('.cell')[0];
    var link = $(this);
    $.ajax({
      url: $(this).attr('href'),
      success: function(data) {
        if (dashboard.length) {
          /* if the user is on the dashboard, remove tile from screen */
          $(cell).hide(300);
        } else {
          $(link).hide();
          $(link).parent().find('.cell-added').remove();
          var $add_to_dashboard = $('<a class="add-to-dashboard new"></a>');
          $add_to_dashboard.attr('href', data.cell_data.add_url);
          $add_to_dashboard.appendTo($(link).parent());
          $(link).remove();
        }
      }
    });
    e.stopPropagation();
    return false;
  });
  $('div.cell, div#sidebar').delegate('a.add-to-dashboard', 'click', function(e) {
    var link = $(this);
    if (link.hasClass('fake')) {
      var next_uri = $(this).attr('href');
      var $dialog = $('<div id="connect-dialog"><span class="close">×</span>' +
                      "<p>La mise en favori nécessite d'être connecté.</p>" +
                      '<div><a class="pk-button" href="/login/?next=' + next_uri +
                              '">Connectez-vous</a>' +
                      '     <a class="pk-button" href="/connect/register/?next=' + next_uri +
                              '">Créer un compte</a></div>' +
                      "</div>");
      $dialog.on('click', function() {
        $dialog.remove();
      });
      $dialog.appendTo($('body'));
    } else {
      $.ajax({
        url: $(this).attr('href'),
        success: function(data) {
          $(link).hide();
          var $added_info = $('<span class="cell-added">Ajouté à votre tableau de bord</span>');
          $added_info.appendTo($(link).parent());
          setTimeout(function() { $added_info.remove(); }, 3000);
          var $remove_from_dashboard = $('<a class="remove-from-dashboard new"></a>');
          $remove_from_dashboard.attr('href', data.cell_data.remove_url);
          $remove_from_dashboard.appendTo($(link).parent());
          $(link).remove();
        }
      });
    }
    e.stopPropagation();
    return false;
  });

  /* map search */
  $('.search-page div.cell.map').addClass('loading').on('combo:map-markers-ready', function() {
    $(this).removeClass('loading');
  });
  $('.search-page div.cell.map').on('combo:map-feature-prepare', function(ev, info) {
    info.layer.on('click', function(ev) {
      $('.leaflet-marker-icon.loading').removeClass('loading');
      if (info.layer.matching_tile) {
        if (info.layer.matching_tile.hasClass('selected')) {
          /* second click on same tile */
          var mql = window.matchMedia("(max-width: 1100px)");
          if (mql.matches) {
            $('#sidebar').css('min-height', 0);
            $('#sidebar .cell').removeClass('selected');
          }
          return;
        }
        $('#sidebar .cell').removeClass('selected');
        info.layer.matching_tile.addClass('selected');
        var $selected_cell = $('#sidebar .cell.selected');
        if ($selected_cell.prev().length) {
          $selected_cell.prependTo($selected_cell.parent());
          $sidebar[0].scrollTop = 0;
        }
        /* on mobile, increase search zone height to make cell visible */
        var mql = window.matchMedia("(max-width: 1100px)");
        if (mql.matches) {
          $('#sidebar').css('min-height', $selected_cell.height() + 10);
        }
        return;
      }
      /* dynamically load tile and put it first */
      $(info.layer._icon).addClass('loading');
      $.ajax({
         url: '/api/dashboard/auto-tile/' + info.layer.feature.properties.layer.identifier + '/',
         data: JSON.stringify(ev.target.feature.properties),
         contentType: 'application/json; charset=utf-8',
         type: 'POST',
         dataType: 'html',
         success: function(html) {
           $(info.layer._icon).removeClass('loading');
           $('#sidebar .cell').removeClass('selected');
           var $tile = $('<div class="cell selected">' + html + '</div>');
           $tile.prependTo($sidebar);
           $sidebar[0].scrollTop = 0;
           if ($tile.siblings().length > 1) {
             $tile.siblings().last()[0].matching_marker.matching_tile = null;
             $tile.siblings().last().remove();
           }
           $tile[0].matching_marker = info.layer;
           info.layer.matching_tile = $tile;

           /* on mobile, increase search zone height to make cell visible */
           var mql = window.matchMedia("(max-width: 1100px)");
           if (mql.matches) {
             $('#sidebar').css('min-height', $tile.height() + 10);
           }
         }
      });
    });
  });

  var MAX_DISPLAYED_RESULTS = 5;
  var $map_search_input = $('#mapsearch input');
  if ($map_search_input.length) {
    var $map_widget = $('div.combo-cell-map');
    var map = $map_widget[0].leaflet_map;
    var search_timeout_id = null;
    var base_geojson_url = $map_widget.data('geojson-url');
    $map_search_input.on('change keyup paste search', function(e) {
      $sidebar.empty();
      clearTimeout(search_timeout_id);
      search_timeout_id = setTimeout(function() {
        var query =  $('#mapsearch input').val();
        var geojson_url = null;
        query = query.toLowerCase();
        query = query.replace(/^rue\s/i, '');
        if (query.length == 0) { // reset view
          geojson_url = base_geojson_url;  // get all markers
          var initial_zoom = parseInt($map_widget.data('init-zoom'));
          map.setZoom(initial_zoom);
        } else if (query.length < 2) {
          return;  // don't react on short query
        } else {
          geojson_url = base_geojson_url + '?q=' + query;
          if ($('body').hasClass('section-autour-de-moi')) {
            var center = map.getCenter();
            var collectivity_slugs = JSON.parse(document.getElementById('collectivity-slugs').textContent);
            var distance_q = '&distance=1000';
            for (var i=0; i<collectivity_slugs.length; i++) {
              if (downcode(query).indexOf(collectivity_slugs[i]) != -1) {
                distance_q = '';
                break;
              }
            }
            geojson_url += '&lat=' + center.lat + '&lng=' + center.lng + distance_q;
          }
        }

        $map_widget.data('geojson-url', geojson_url);
        map.add_geojson_layer(function(geo_json) {
          var layers = geo_json.getLayers();
          var map_bounds = map.getBounds();
          var found = 0;
          var found_in_padded_bounds = false;
          if (layers.length == 0) return;
          for (var i=0; i<layers.length; i++) {
            if (map_bounds.contains(layers[i].getLatLng())) {
              found += 1;
            }
          }
          if (!found) {
            /* no visible marker */
            if (layers.length == 1) {
              map.flyTo(layers[0].getLatLng());
            }
            var bounds = geo_json.getBounds();
            map.flyToBounds(bounds);
          } else {
            if (map.getZoom() < 16) {
              if (layers.length == 1) {
                map.flyTo(layers[0].getLatLng(), 16);
              } else if (layers.length == found) {
                var bounds = geo_json.getBounds();
                map.flyToBounds(bounds);
              } else if (layers.length <= 10) {
                var bounds = geo_json.getBounds();
                map.flyToBounds(bounds);
              }
            } else {
              if (layers.length <= 10 && layers.length != found) {
                var bounds = geo_json.getBounds();
                map.flyToBounds(bounds);
              }
            }
          }
          $(document).trigger('gnm:new-results');
        });
        search_timeout_id = null;
      }, 300);
    });
    $('#mapsearch').on('submit', function() {
      // live search but we trigger the change event to be sure
      $map_search_input.trigger('change');
      return false;
    });
    $(map).on('movestart', function() {
      var mql = window.matchMedia("(max-width: 1100px)");
      if (mql.matches) {
        $('#sidebar').css('min-height', 0);
      }
    });
    $(map).on('zoomend moveend', function() {
      $(document).trigger('gnm:new-results');
    });
    $(document).on('gnm:new-results', function(ev, params) {
      params = params || {};
      if (map.clustered_markers) {
        map.clustered_markers.on('spiderfied', function() {
          $(document).trigger('gnm:new-results', {'loadmore': true});
        });
      }
      if ($sidebar.length == 0) return;
      if (! params.loadmore) {
        $sidebar.addClass('loading');
      }
      var counter = 0;
      var tile_counter = 0;
      var cluster_groups = Array();
      $sidebar.find('> div.cell').each(function(idx, tile) {
        // remove out of bounds results
        if (tile.matching_marker == undefined || ! map.getBounds().contains(tile.matching_marker.getLatLng())) {
          if (tile.matching_marker) {
            tile.matching_marker.matching_tile = null;
          }
          $(tile).remove();
        }
      });
      map.eachLayer(function(layer) {
        if (layer instanceof L.Marker) {
          if (layer.gps_marker !== undefined) {
            return;
          }
          if (! map.getBounds().contains(layer.getLatLng())) {
                  return;
          }
          if (layer._childCount !== undefined) {
            cluster_groups.push(layer);
            return;
          }
          var $tile = $('[data-leaflet-id="' + L.stamp(layer) + '"]');
          if ($tile.length && params.loadmore) {
            return;
          }
          if (counter > MAX_DISPLAYED_RESULTS) return;
          counter += 1;

          if ($tile.length) {
            return;
          }

          $tile = $('<div class="cell" data-leaflet-id="' + L.stamp(layer) + '"><div class="tile placeholder">' +
                      '<div class="tile-picture"></div>' +
                      '<div class="tile-head"><div class="tile-title"><h2></h2><span class="producer"></span></div></div>' +
                    ' </div></div>');
          $tile.appendTo($sidebar);
          $.ajax({
            url: '/api/dashboard/auto-tile/' + layer.feature.properties.layer.identifier + '/',
            data: JSON.stringify(layer.feature.properties),
            contentType: 'application/json; charset=utf-8',
            type: 'POST',
            dataType: 'html',
            success: function(html) {
              if (layer.matching_tile) {
                $(layer.matching_tile).remove();
                layer.matching_tile = null;
              }
              $tile.html(html);
              $sidebar.removeClass('empty');
              $tile[0].matching_marker = layer;
              layer.matching_tile = $tile;
              $tile.on('click', function(ev) {
                if (ev.target.nodeName != 'A') {
                  map.flyTo(layer.getLatLng(), 18);
                }
                return true;
              });
              tile_counter += 1;
              if (tile_counter == counter) {
                $sidebar.removeClass('loading');
              }
              $sidebar.removeClass('empty');
              $('#empty-map-results').remove();
            }
          });
        }
      });
      if (counter == 0) {
        /* remove loading marker if there were no tiles */
        $sidebar.removeClass('loading');
      }
      if (counter == 0 && $('div.cell.map.loading').length == 0) {
        $sidebar.addClass('empty');
        var $empty = $('#empty-map-results');
        if ($empty.length == 0 && $sidebar.find('> div.cell').length == 0 && ! params.loadmore) {
          $empty = $('<p id="empty-map-results"></p>');
          $empty.text('Aucun résultat dans cette zone.');
          $empty.appendTo($sidebar);
        }
        if (cluster_groups.length && $sidebar.find('> div.cell').length == 0 && ! params.loadmore) {
          $empty.text("Cliquez ou zoomez sur un point d'intérêt...");
        }
      }
    });
    if ($map_search_input.val()) { /* prefilled from query string */
      $map_search_input.trigger('change');
    } else {
      $('div.cell.map').on('combo:map-ready', function() {
        $(document).trigger('gnm:new-results');
      });
    }

    $('div.suggestions span').on('click', function() {
      $map_search_input.val($(this).text()).trigger('change');
    });

    $sidebar.scroll(function() {
      if ($sidebar.scrollTop() + $sidebar.innerHeight() >= $sidebar[0].scrollHeight) {
        if ($sidebar.hasClass('everything-loaded')) {
          return;
        }
        $(document).trigger('gnm:new-results', {'loadmore': true});
      }
    });
  }

  /* map on place pages */
  $('#content').delegate('.is-place div.cell.map', 'gnm:add-marker combo:map-ready', function() {
    var $map_widget = $(this).find('div.combo-cell-map');
    var map = $map_widget[0].leaflet_map;
    var place_type = $(this).parents('.tile').data('place-type');
    if (place_type) {
      var marker = L.divIcon({
          iconAnchor: [0, 0],
          popupAnchor: [5, -45],
          html: '<span class="layer-' + place_type + '"><i class="leaflet-marker-icon"></i></span>'
      });
      L.marker([$map_widget.data('init-lat'), $map_widget.data('init-lng')], {icon: marker}).addTo(map);
    }
  });
  if ($('#content .is-place div.cell.map').length) {
    var $map_widget = $(this).find('div.combo-cell-map');
    var map = $map_widget[0].leaflet_map;
    if (map !== undefined) {
      map.whenReady(function() {
       $('.is-place div.cell.map').trigger('gnm:add-marker');
      });
    }
  }

  /* section collapsing/expanding */
  $('div.group-title').on('click', function() {
    var expand = $(this).hasClass('closed');
    var tile = $(this);
    var dashboard_parent = false;
    while (true) {
      tile = $(tile).next();
      if (tile.length == 0) break;
      if (tile.hasClass('dashboardcell')) {
        tile = $(tile).find('.cell');
        dashboard_parent = true;
      }
      if (tile.hasClass('wcscurrentformscell') || tile.hasClass('wcscurrentdraftscell')) {
        /* get inside */
        tile = $(tile).find('.tile');
      }
      if (tile.hasClass('group-title')) {
        break;
      }
      if (! (tile.hasClass('tile') || tile.hasClass('linkcell') || dashboard_parent)) {
        break;
      }
      if (expand) {
        $(tile).removeClass('closed');
      } else {
        $(tile).addClass('closed');
      }
    }
    if (expand) {
      $(this).removeClass('closed');
    } else {
      $(this).addClass('closed');
    }
  });
  /* collapse services sections by default on mobiles */
  var mql = window.matchMedia("screen and (max-width: 480px)");
  if (mql.matches) {
    $('div.group-title').trigger('click');
  }

  /* add service count labels */
  if ($('.dashboardcell').length == 0) {
    $('.group-title').each(function() {
      var $group = $(this);
      var count = 0;
      var tile = $(this);
      while (true) {
        tile = $(tile).next();
        if (tile.length == 0) break;
        if (tile.hasClass('group-title')) {
          break;
        }
        if (! (tile.hasClass('tile') || tile.hasClass('linkcell'))) {
          break;
        }
        count += 1;
      }
      if (count) {
        $(this).find('h2').append(' <span class="count">(' + count + ')</span>');
      }
    });
  }

  /* dashboard ordering */
  $('div.dashboard-content div.cell').delegate('div.tile a', 'click', function(e) {
    e.stopPropagation();
  });

  $('.dashboard-content div.cell').delegate('div.tile', 'click', function() {
    $(this).parents('.dashboard-content').toggleClass('edit-mode');
    return false;
  });

  $('div.dashboard-content div.cell').delegate('div.tile span.move-up', 'click', function() {
    if ($(this).parents('.edit-mode').length == 0) return;
    var $cell = $($(this).closest('.cell')[0]);
    var tile_bottom_margin = 14 / 2; /* see _tiles.css */
    var cell_height = $cell.height() + tile_bottom_margin;
    var $dashboard_content = $(this).closest('.dashboard-content');
    var $prev_cell = $($cell.prev()[0]);
    var prev_cell_height = $prev_cell.height() + tile_bottom_margin;
    $prev_cell.insertAfter($cell);
    var new_order = $.map($dashboard_content.find('> div'), function(val) { return $(val).data('tile-id'); }).join(',');
    $.ajax({
      url: $dashboard_content.data('dashboard-reorder-url') + '?order=' + new_order,
    });
    $cell.css('transition-duration', '0ms');
    $cell.css('z-index', '100');
    $prev_cell.css('transition-duration', '0ms');
    $cell[0].offsetHeight; /* commit */
    $cell.css('transform', 'translate(0px, ' + prev_cell_height + 'px)');
    $prev_cell.css('transform', 'translate(0px, -' + cell_height + 'px)');
    $cell[0].offsetHeight; /* commit */
    $cell.css('transition-duration', '300ms');
    $prev_cell.css('transition-duration', '300ms');
    $cell[0].offsetHeight; /* commit */
    $cell.css('transform', 'translate(0px, 0)');
    $prev_cell.css('transform', 'translate(0px, 0)');
    setTimeout(function() { $cell.css('z-index', '0'); }, 300);

    return false;
  });

  /* collectivity selector */
  $('div.mairie-usager').delegate('select#collectivities', 'change', function(a, b) {
    var $selected = $(this).find(':selected');
    if ($selected.data('url')) {
      window.location = $selected.data('url');
    }
  });

  /* notifications */
  $('div.notification').on('click', function() {
    var cell = $(this);
    if ($(cell).hasClass('acked')) {
      if ($(cell).find('h3 a').length) {
        window.location.href = $(cell).find('h3 a').attr('href');
      }
      return false;
    }
    var ack_url = $(this).data('combo-notification-ack-url');
    $.ajax({
         url: ack_url,
         success: function(html) {
           $(cell).removeClass('new').addClass('acked');
           if ($(cell).find('h3 a').length) {
             window.location.href = $(cell).find('h3 a').attr('href');
           }
         }
    });
    return false;
  });
  $('div.notification a.delete').on('click', function(event) {
    var notification = $(this).parents('.notification');
    var forget_url = $(notification).data('combo-notification-forget-url');
    $.ajax({
         url: forget_url,
         success: function(html) {
           $(notification).hide({effect: 'fade', complete: function() { $(this).remove() }});
         }
    });
    return false;
  });

  /* click on "connectez-vous" blocks */
  $('div#connectez-vous').on('click', function() {
    window.location = '/login/';
    return false;
  });

  /* click on "ajouter un service" blocks */
  $('div#ajouter-service').on('click', function() {
    window.location = '/services/';
    return false;
  });

  $('#content').delegate('[data-switch-day-prev]', 'click', function() {
    $(this).parents('.tables').hide().prev().show();
  });

  $('#content').delegate('[data-switch-day-next]', 'click', function() {
    $(this).parents('.tables').hide().next().show();
  });

  $('#cell-filter input').on('change keyup paste', function() {
    var q = downcode($(this).val());
    if (q) {
      $('#columns > .tile, .dashboard-content > div.cell').each(function() {
        var cell_text = downcode($(this).text() + ' ' +
                $(this).find('[data-keywords]').data('keywords') + ' ' +
                $(this)[0].className);
        if (cell_text.search(q) == -1) {
          $(this).hide();
        } else {
          $(this).show();
        }
      });
      var has_any_visible_cells = false;
      $('#columns > .group-title').each(function() {
        var $tile = $(this);
        var has_visible_cells = false;
        while (true) {
          $tile = $tile.next();
          if ($tile.hasClass('filter-empty')) continue;
          if ($tile.length == 0) break;
          if ($tile.hasClass('group-title')) break;
          if ($tile.is(':visible')) {
            has_visible_cells = true;
            has_any_visible_cells = true;
            break;
          }
        }
        if (has_visible_cells) {
          $(this).show();
        } else {
          $(this).hide();
        }
      });
      if (has_any_visible_cells) {
        $('#columns > .filter-empty').remove();
      } else {
        if ($('.filter-empty').length == 0) {
          $('<div class="cell grid-1-1 newline filter-empty"><p>Aucun résultat.</p></div>').appendTo($('#columns'));
        }
      }
    } else {
      $('#columns > .tile, .dashboard-content > div.cell').show();
      $('#columns > .group-title').show();
    }
  });

  $(document).on('combo:cell-loaded', function(ev, elem) {
    /* remove empty cells from DOM, this helps later operations such as
     * dashboard reordering to only have actual visible cells */
    if ($(elem).height() == 0) $(elem).remove();

    /* "your profile" cell */
    var drafts_count = $('.wcscurrentdraftscell .tile').length
    var forms_count = $('.wcscurrentformscell .tile').length
    if ($('.wcscurrentdraftscell .tile.info').length) drafts_count = 0;
    if ($('.wcscurrentformscell .tile.info').length) forms_count = 0;
    $('.drafts-count').text(drafts_count);
    $('.forms-count').text(forms_count);
    if (drafts_count < 2) {
      $('.drafts-count').next().text('brouillon');
    } else {
      $('.drafts-count').next().text('brouillons');
    }
    if (forms_count < 2) {
      $('.forms-count').next().text('demande');
    } else {
      $('.forms-count').next().text('demandes');
    }
  });

  $('.cell.open-in-new-window a').each(function() {
    $(this).attr('target', '_blank').attr('rel', 'noopener');
  });
});
